Index: trunk/NEMO/LIM_SRC_2/limrhg_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limrhg_2.F90	(revision 873)
+++ trunk/NEMO/LIM_SRC_2/limrhg_2.F90	(revision 888)
@@ -182,470 +212,357 @@
          ! Computation of free drift field for free slip boundary conditions.
 
-           DO jj = k_j1, k_jpj-1
-              DO ji = 1, jpim1
-                 !- Rate of strain tensor.
-                 zt11 =   akappa(ji,jj,1,1) * ( u_ice(ji+1,jj) + u_ice(ji+1,jj+1) - u_ice(ji,jj  ) - u_ice(ji  ,jj+1) )  &
-                    &   + akappa(ji,jj,1,2) * ( v_ice(ji+1,jj) + v_ice(ji+1,jj+1) + v_ice(ji,jj  ) + v_ice(ji  ,jj+1) )
-                 zt12 = - akappa(ji,jj,2,2) * ( u_ice(ji  ,jj) + u_ice(ji+1,jj  ) - u_ice(ji,jj+1) - u_ice(ji+1,jj+1) )  &
-                    &   - akappa(ji,jj,2,1) * ( v_ice(ji  ,jj) + v_ice(ji+1,jj  ) + v_ice(ji,jj+1) + v_ice(ji+1,jj+1) )
-                 zt22 = - akappa(ji,jj,2,2) * ( v_ice(ji  ,jj) + v_ice(ji+1,jj  ) - v_ice(ji,jj+1) - v_ice(ji+1,jj+1) )  &
-                    &   + akappa(ji,jj,2,1) * ( u_ice(ji  ,jj) + u_ice(ji+1,jj  ) + u_ice(ji,jj+1) + u_ice(ji+1,jj+1) )
-                 zt21 =   akappa(ji,jj,1,1) * ( v_ice(ji+1,jj) + v_ice(ji+1,jj+1) - v_ice(ji,jj  ) - v_ice(ji  ,jj+1) )  &
-                    &   - akappa(ji,jj,1,2) * ( u_ice(ji+1,jj) + u_ice(ji+1,jj+1) + u_ice(ji,jj  ) + u_ice(ji  ,jj+1) )
-
-                 !- Rate of strain tensor. 
-                 zdgp = zt11 + zt22
-                 zdgi = zt12 + zt21
-                 ztrace2 = zdgp * zdgp 
-                 zdeter  = zt11 * zt22 - 0.25 * zdgi * zdgi
-
-                 !  Creep limit depends on the size of the grid.
-                 zdelta = MAX( SQRT( ztrace2 + ( ztrace2 - 4.0 * zdeter ) * usecc2),  creepl)
-
-                 !-  Computation of viscosities.
-                 zviszeta(ji,jj) = MAX( zpresh(ji,jj) / zdelta, etamn )
-                 zviseta (ji,jj) = zviszeta(ji,jj) * usecc2
-              END DO
-           END DO
-!!??       CALL lbc_lnk( zviszeta, 'I', -1. )  ! or T point???   semble reellement inutile
-!!??       CALL lbc_lnk( zviseta , 'I', -1. )
-
-
-           !-  Determination of zc1u, zc2u, zc1v and zc2v.
-           DO jj = k_j1+1, k_jpj-1
-              DO ji = 2, jpim1
-                 ze11   =  akappa(ji-1,jj-1,1,1)
-                 ze12   = +akappa(ji-1,jj-1,2,2)
-                 ze22   =  akappa(ji-1,jj-1,2,1)
-                 ze21   = -akappa(ji-1,jj-1,1,2)
-                 zvis11 = 2.0 * zviseta (ji-1,jj-1) + dm
-                 zvis22 =       zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
-                 zvis12 =       zviseta (ji-1,jj-1) + dm
-                 zvis21 =       zviseta (ji-1,jj-1)
-
-                 zdiag = zvis22 * ( ze11 + ze22 )
-                 zs11(ji,jj,1,1) =  zvis11 * ze11 + zdiag
-                 zs12(ji,jj,1,1) =  zvis12 * ze12 + zvis21 * ze21
-                 zs22(ji,jj,1,1) =  zvis11 * ze22 + zdiag
-                 zs21(ji,jj,1,1) =  zvis12 * ze21 + zvis21 * ze12
-
-                 ze11   = -akappa(ji,jj-1,1,1)
-                 ze12   = +akappa(ji,jj-1,2,2)
-                 ze22   =  akappa(ji,jj-1,2,1)
-                 ze21   = -akappa(ji,jj-1,1,2)
-                 zvis11 = 2.0 * zviseta (ji,jj-1) + dm
-                 zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
-                 zvis12 =       zviseta (ji,jj-1) + dm
-                 zvis21 =       zviseta (ji,jj-1)
-
-                 zdiag = zvis22 * ( ze11 + ze22 )
-                 zs11(ji,jj,2,1) =  zvis11 * ze11 + zdiag
-                 zs12(ji,jj,2,1) =  zvis12 * ze12 + zvis21 * ze21
-                 zs22(ji,jj,2,1) =  zvis11 * ze22 + zdiag
-                 zs21(ji,jj,2,1) =  zvis12 * ze21 + zvis21 * ze12
-
-                 ze11   =  akappa(ji-1,jj,1,1)
-                 ze12   = -akappa(ji-1,jj,2,2)
-                 ze22   =  akappa(ji-1,jj,2,1)
-                 ze21   = -akappa(ji-1,jj,1,2)
-                 zvis11 = 2.0 * zviseta (ji-1,jj) + dm
-                 zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
-                 zvis12 =       zviseta (ji-1,jj) + dm
-                 zvis21 =       zviseta (ji-1,jj)
-
-                 zdiag = zvis22 * ( ze11 + ze22 ) 
-                 zs11(ji,jj,1,2) =  zvis11 * ze11 + zdiag
-                 zs12(ji,jj,1,2) =  zvis12 * ze12 + zvis21 * ze21
-                 zs22(ji,jj,1,2) =  zvis11 * ze22 + zdiag
-                 zs21(ji,jj,1,2) =  zvis12 * ze21 + zvis21 * ze12
-
-                 ze11   = -akappa(ji,jj,1,1)
-                 ze12   = -akappa(ji,jj,2,2)
-                 ze22   =  akappa(ji,jj,2,1)
-                 ze21   = -akappa(ji,jj,1,2)
-                 zvis11 = 2.0 * zviseta (ji,jj) + dm
-                 zvis22 =       zviszeta(ji,jj) - zviseta(ji,jj)
-                 zvis12 =       zviseta (ji,jj) + dm
-                 zvis21 =       zviseta (ji,jj)
-
-                 zdiag = zvis22 * ( ze11 + ze22 )
-                 zs11(ji,jj,2,2) =  zvis11 * ze11 + zdiag
-                 zs12(ji,jj,2,2) =  zvis12 * ze12 + zvis21 * ze21
-                 zs22(ji,jj,2,2) =  zvis11 * ze22 + zdiag 
-                 zs21(ji,jj,2,2) =  zvis12 * ze21 + zvis21 * ze12
-              END DO
-           END DO
-
-           DO jj = k_j1+1, k_jpj-1
-              DO ji = 2, jpim1
-                 zc1u(ji,jj) =   &
-                    + alambd(ji,jj,2,2,2,1) * zs11(ji,jj,2,1) + alambd(ji,jj,2,2,2,2) * zs11(ji,jj,2,2)   &
-                    - alambd(ji,jj,2,2,1,1) * zs11(ji,jj,1,1) - alambd(ji,jj,2,2,1,2) * zs11(ji,jj,1,2)   &
-                    - alambd(ji,jj,1,1,2,1) * zs12(ji,jj,2,1) - alambd(ji,jj,1,1,1,1) * zs12(ji,jj,1,1)   &
-                    + alambd(ji,jj,1,1,2,2) * zs12(ji,jj,2,2) + alambd(ji,jj,1,1,1,2) * zs12(ji,jj,1,2)   &
-                    + alambd(ji,jj,1,2,1,1) * zs21(ji,jj,1,1) + alambd(ji,jj,1,2,2,1) * zs21(ji,jj,2,1)   &
-                    + alambd(ji,jj,1,2,1,2) * zs21(ji,jj,1,2) + alambd(ji,jj,1,2,2,2) * zs21(ji,jj,2,2)   &
-                    - alambd(ji,jj,2,1,1,1) * zs22(ji,jj,1,1) - alambd(ji,jj,2,1,2,1) * zs22(ji,jj,2,1)   &
-                    - alambd(ji,jj,2,1,1,2) * zs22(ji,jj,1,2) - alambd(ji,jj,2,1,2,2) * zs22(ji,jj,2,2)
-                 
-                 zc2u(ji,jj) =   &
-                    + alambd(ji,jj,2,2,2,1) * zs21(ji,jj,2,1) + alambd(ji,jj,2,2,2,2) * zs21(ji,jj,2,2)   &
-                    - alambd(ji,jj,2,2,1,1) * zs21(ji,jj,1,1) - alambd(ji,jj,2,2,1,2) * zs21(ji,jj,1,2)   &
-                    - alambd(ji,jj,1,1,2,1) * zs22(ji,jj,2,1) - alambd(ji,jj,1,1,1,1) * zs22(ji,jj,1,1)   &
-                    + alambd(ji,jj,1,1,2,2) * zs22(ji,jj,2,2) + alambd(ji,jj,1,1,1,2) * zs22(ji,jj,1,2)   &
-                    - alambd(ji,jj,1,2,1,1) * zs11(ji,jj,1,1) - alambd(ji,jj,1,2,2,1) * zs11(ji,jj,2,1)   &
-                    - alambd(ji,jj,1,2,1,2) * zs11(ji,jj,1,2) - alambd(ji,jj,1,2,2,2) * zs11(ji,jj,2,2)   &
-                    + alambd(ji,jj,2,1,1,1) * zs12(ji,jj,1,1) + alambd(ji,jj,2,1,2,1) * zs12(ji,jj,2,1)   &
-                    + alambd(ji,jj,2,1,1,2) * zs12(ji,jj,1,2) + alambd(ji,jj,2,1,2,2) * zs12(ji,jj,2,2)
-             END DO
-           END DO
-
-           DO jj = k_j1+1, k_jpj-1
-              DO ji = 2, jpim1
-                 !  zc1v , zc2v.
-                 ze11   =  akappa(ji-1,jj-1,1,2)
-                 ze12   = -akappa(ji-1,jj-1,2,1)
-                 ze22   = +akappa(ji-1,jj-1,2,2)
-                 ze21   =  akappa(ji-1,jj-1,1,1)
-                 zvis11 = 2.0 * zviseta (ji-1,jj-1) + dm
-                 zvis22 =       zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
-                 zvis12 =       zviseta (ji-1,jj-1) + dm
-                 zvis21 =       zviseta (ji-1,jj-1)
-
-                 zdiag = zvis22 * ( ze11 + ze22 )
-                 zs11(ji,jj,1,1) =  zvis11 * ze11 + zdiag
-                 zs12(ji,jj,1,1) =  zvis12 * ze12 + zvis21 * ze21
-                 zs22(ji,jj,1,1) =  zvis11 * ze22 + zdiag
-                 zs21(ji,jj,1,1) =  zvis12 * ze21 + zvis21 * ze12
+!CDIR NOVERRCHK
+         DO jj = k_j1, k_jpj-1
+!CDIR NOVERRCHK
+            DO ji = 1, fs_jpim1
+               !- Rate of strain tensor.
+               zt11 =   akappa(ji,jj,1,1) * ( zu_a(ji+1,jj) + zu_a(ji+1,jj+1) - zu_a(ji,jj  ) - zu_a(ji  ,jj+1) )  &
+                  &   + akappa(ji,jj,1,2) * ( zv_a(ji+1,jj) + zv_a(ji+1,jj+1) + zv_a(ji,jj  ) + zv_a(ji  ,jj+1) )
+               zt12 = - akappa(ji,jj,2,2) * ( zu_a(ji  ,jj) + zu_a(ji+1,jj  ) - zu_a(ji,jj+1) - zu_a(ji+1,jj+1) )  &
+                  &   - akappa(ji,jj,2,1) * ( zv_a(ji  ,jj) + zv_a(ji+1,jj  ) + zv_a(ji,jj+1) + zv_a(ji+1,jj+1) )
+               zt22 = - akappa(ji,jj,2,2) * ( zv_a(ji  ,jj) + zv_a(ji+1,jj  ) - zv_a(ji,jj+1) - zv_a(ji+1,jj+1) )  &
+                  &   + akappa(ji,jj,2,1) * ( zu_a(ji  ,jj) + zu_a(ji+1,jj  ) + zu_a(ji,jj+1) + zu_a(ji+1,jj+1) )
+               zt21 =   akappa(ji,jj,1,1) * ( zv_a(ji+1,jj) + zv_a(ji+1,jj+1) - zv_a(ji,jj  ) - zv_a(ji  ,jj+1) )  &
+                  &   - akappa(ji,jj,1,2) * ( zu_a(ji+1,jj) + zu_a(ji+1,jj+1) + zu_a(ji,jj  ) + zu_a(ji  ,jj+1) )
+
+               !- Rate of strain tensor. 
+               zdgp = zt11 + zt22
+               zdgi = zt12 + zt21
+               ztrace2 = zdgp * zdgp 
+               zdeter  = zt11 * zt22 - 0.25 * zdgi * zdgi
+
+               !  Creep limit depends on the size of the grid.
+               zdelta = MAX( SQRT( ztrace2 + ( ztrace2 - 4.0 * zdeter ) * usecc2 ),  creepl)
+
+               !-  Computation of viscosities.
+               zviszeta(ji,jj) = MAX( zpresh(ji,jj) / zdelta, etamn )
+               zviseta (ji,jj) = zviszeta(ji,jj) * usecc2
+            END DO
+         END DO
+
+         !-  Determination of zc1u, zc2u, zc1v and zc2v.
+         DO jj = k_j1+1, k_jpj-1
+            DO ji = fs_2, fs_jpim1
+               !* zc1u , zc2v
+               zvis11 = 2.0 * zviseta (ji-1,jj-1) + dm
+               zvis12 =       zviseta (ji-1,jj-1) + dm
+               zvis21 =       zviseta (ji-1,jj-1)
+               zvis22 =       zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
+               zdiag  = zvis22 * ( akappa(ji-1,jj-1,1,1) + akappa(ji-1,jj-1,2,1) )
+               zs11_11 =  zvis11 * akappa(ji-1,jj-1,1,1) + zdiag
+               zs12_11 =  zvis12 * akappa(ji-1,jj-1,2,2) - zvis21 * akappa(ji-1,jj-1,1,2)
+               zs21_11 = -zvis12 * akappa(ji-1,jj-1,1,2) + zvis21 * akappa(ji-1,jj-1,2,2)
+               zs22_11 =  zvis11 * akappa(ji-1,jj-1,2,1) + zdiag
+
+               zvis11 = 2.0 * zviseta (ji,jj-1) + dm
+               zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
+               zvis12 =       zviseta (ji,jj-1) + dm
+               zvis21 =       zviseta (ji,jj-1)
+               zdiag = zvis22 * ( -akappa(ji,jj-1,1,1) + akappa(ji,jj-1,2,1) )
+               zs11_21 = -zvis11 * akappa(ji,jj-1,1,1) + zdiag
+               zs12_21 =  zvis12 * akappa(ji,jj-1,2,2) - zvis21 * akappa(ji,jj-1,1,2)
+               zs22_21 =  zvis11 * akappa(ji,jj-1,2,1) + zdiag
+               zs21_21 = -zvis12 * akappa(ji,jj-1,1,2) + zvis21 * akappa(ji,jj-1,2,2)
+
+               zvis11 = 2.0 * zviseta (ji-1,jj) + dm
+               zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
+               zvis12 =       zviseta (ji-1,jj) + dm
+               zvis21 =       zviseta (ji-1,jj)
+               zdiag = zvis22 * ( akappa(ji-1,jj,1,1) + akappa(ji-1,jj,2,1) )
+               zs11_12 =  zvis11 * akappa(ji-1,jj,1,1) + zdiag
+               zs12_12 = -zvis12 * akappa(ji-1,jj,2,2) - zvis21 * akappa(ji-1,jj,1,2)
+               zs22_12 =  zvis11 * akappa(ji-1,jj,2,1) + zdiag
+               zs21_12 = -zvis12 * akappa(ji-1,jj,1,2) - zvis21 * akappa(ji-1,jj,2,2)
+
+               zvis11 = 2.0 * zviseta (ji,jj) + dm
+               zvis22 =       zviszeta(ji,jj) - zviseta(ji,jj)
+               zvis12 =       zviseta (ji,jj) + dm
+               zvis21 =       zviseta (ji,jj)
+               zdiag = zvis22 * ( -akappa(ji,jj,1,1) + akappa(ji,jj,2,1) )
+               zs11_22 = -zvis11 * akappa(ji,jj,1,1) + zdiag
+               zs12_22 = -zvis12 * akappa(ji,jj,2,2) - zvis21 * akappa(ji,jj,1,2)
+               zs22_22 =  zvis11 * akappa(ji,jj,2,1) + zdiag
+               zs21_22 = -zvis12 * akappa(ji,jj,1,2) - zvis21 * akappa(ji,jj,2,2)
+
+               zc1u(ji,jj) = + alambd(ji,jj,2,2,2,1) * zs11_21 + alambd(ji,jj,2,2,2,2) * zs11_22   &
+                  &          - alambd(ji,jj,2,2,1,1) * zs11_11 - alambd(ji,jj,2,2,1,2) * zs11_12   &
+                  &          - alambd(ji,jj,1,1,2,1) * zs12_21 - alambd(ji,jj,1,1,1,1) * zs12_11   &
+                  &          + alambd(ji,jj,1,1,2,2) * zs12_22 + alambd(ji,jj,1,1,1,2) * zs12_12   &
+                  &          + alambd(ji,jj,1,2,1,1) * zs21_11 + alambd(ji,jj,1,2,2,1) * zs21_21   &
+                  &          + alambd(ji,jj,1,2,1,2) * zs21_12 + alambd(ji,jj,1,2,2,2) * zs21_22   &
+                  &          - alambd(ji,jj,2,1,1,1) * zs22_11 - alambd(ji,jj,2,1,2,1) * zs22_21   &
+                  &          - alambd(ji,jj,2,1,1,2) * zs22_12 - alambd(ji,jj,2,1,2,2) * zs22_22
+
+               zc2u(ji,jj) = + alambd(ji,jj,2,2,2,1) * zs21_21 + alambd(ji,jj,2,2,2,2) * zs21_22   &
+                  &          - alambd(ji,jj,2,2,1,1) * zs21_11 - alambd(ji,jj,2,2,1,2) * zs21_12   &
+                  &          - alambd(ji,jj,1,1,2,1) * zs22_21 - alambd(ji,jj,1,1,1,1) * zs22_11   &
+                  &          + alambd(ji,jj,1,1,2,2) * zs22_22 + alambd(ji,jj,1,1,1,2) * zs22_12   &
+                  &          - alambd(ji,jj,1,2,1,1) * zs11_11 - alambd(ji,jj,1,2,2,1) * zs11_21   &
+                  &          - alambd(ji,jj,1,2,1,2) * zs11_12 - alambd(ji,jj,1,2,2,2) * zs11_22   &
+                  &          + alambd(ji,jj,2,1,1,1) * zs12_11 + alambd(ji,jj,2,1,2,1) * zs12_21   &
+                  &          + alambd(ji,jj,2,1,1,2) * zs12_12 + alambd(ji,jj,2,1,2,2) * zs12_22
+
+               !* zc1v , zc2v.
+               zvis11 = 2.0 * zviseta (ji-1,jj-1) + dm
+               zvis22 =       zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
+               zvis12 =       zviseta (ji-1,jj-1) + dm
+               zvis21 =       zviseta (ji-1,jj-1)
+               zdiag = zvis22 * ( akappa(ji-1,jj-1,1,2) + akappa(ji-1,jj-1,2,2) )
+               zs11_11 =  zvis11 * akappa(ji-1,jj-1,1,2) + zdiag
+               zs12_11 = -zvis12 * akappa(ji-1,jj-1,2,1) + zvis21 * akappa(ji-1,jj-1,1,1)
+               zs22_11 =  zvis11 * akappa(ji-1,jj-1,2,2) + zdiag
+               zs21_11 =  zvis12 * akappa(ji-1,jj-1,1,1) - zvis21 * akappa(ji-1,jj-1,2,1)
  
-                 ze11   =  akappa(ji,jj-1,1,2)
-                 ze12   = -akappa(ji,jj-1,2,1)
-                 ze22   = +akappa(ji,jj-1,2,2)
-                 ze21   = -akappa(ji,jj-1,1,1)
-                 zvis11 = 2.0 * zviseta (ji,jj-1) + dm
-                 zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
-                 zvis12 =       zviseta (ji,jj-1) + dm
-                 zvis21 =       zviseta (ji,jj-1)
-
-                 zdiag = zvis22 * ( ze11 + ze22 )
-                 zs11(ji,jj,2,1) =  zvis11 * ze11 + zdiag
-                 zs12(ji,jj,2,1) =  zvis12 * ze12 + zvis21 * ze21
-                 zs22(ji,jj,2,1) =  zvis11 * ze22 + zdiag
-                 zs21(ji,jj,2,1) =  zvis12 * ze21 + zvis21 * ze12
-
-                 ze11   =  akappa(ji-1,jj,1,2)
-                 ze12   = -akappa(ji-1,jj,2,1)
-                 ze22   = -akappa(ji-1,jj,2,2)
-                 ze21   =  akappa(ji-1,jj,1,1)
-                 zvis11 = 2.0 * zviseta (ji-1,jj) + dm
-                 zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
-                 zvis12 =       zviseta (ji-1,jj) + dm
-                 zvis21 =       zviseta (ji-1,jj)
-
-                 zdiag = zvis22 * ( ze11 + ze22 )
-                 zs11(ji,jj,1,2) =  zvis11 * ze11 + zdiag
-                 zs12(ji,jj,1,2) =  zvis12 * ze12 + zvis21 * ze21
-                 zs22(ji,jj,1,2) =  zvis11 * ze22 + zdiag
-                 zs21(ji,jj,1,2) =  zvis12 * ze21 + zvis21 * ze12
-
-                 ze11   =  akappa(ji,jj,1,2)
-                 ze12   = -akappa(ji,jj,2,1)
-                 ze22   = -akappa(ji,jj,2,2)
-                 ze21   = -akappa(ji,jj,1,1)
-                 zvis11 = 2.0 * zviseta (ji,jj) + dm
-                 zvis22 =       zviszeta(ji,jj) - zviseta(ji,jj)
-                 zvis12 =       zviseta (ji,jj) + dm
-                 zvis21 =       zviseta (ji,jj)
-
-                 zdiag = zvis22 * ( ze11 + ze22 )
-                 zs11(ji,jj,2,2) =  zvis11 * ze11 + zdiag
-                 zs12(ji,jj,2,2) =  zvis12 * ze12 + zvis21 * ze21
-                 zs22(ji,jj,2,2) =  zvis11 * ze22 + zdiag
-                 zs21(ji,jj,2,2) =  zvis12 * ze21 + zvis21 * ze12
-
-              END DO
-           END DO
-
-           DO jj = k_j1+1, k_jpj-1
-              DO ji = 2, jpim1
-                 zc1v(ji,jj) =   &
-                    + alambd(ji,jj,2,2,2,1) * zs11(ji,jj,2,1) + alambd(ji,jj,2,2,2,2) * zs11(ji,jj,2,2)   &
-                    - alambd(ji,jj,2,2,1,1) * zs11(ji,jj,1,1) - alambd(ji,jj,2,2,1,2) * zs11(ji,jj,1,2)   &
-                    - alambd(ji,jj,1,1,2,1) * zs12(ji,jj,2,1) - alambd(ji,jj,1,1,1,1) * zs12(ji,jj,1,1)   &
-                    + alambd(ji,jj,1,1,2,2) * zs12(ji,jj,2,2) + alambd(ji,jj,1,1,1,2) * zs12(ji,jj,1,2)   &
-                    + alambd(ji,jj,1,2,1,1) * zs21(ji,jj,1,1) + alambd(ji,jj,1,2,2,1) * zs21(ji,jj,2,1)   &
-                    + alambd(ji,jj,1,2,1,2) * zs21(ji,jj,1,2) + alambd(ji,jj,1,2,2,2) * zs21(ji,jj,2,2)   &
-                    - alambd(ji,jj,2,1,1,1) * zs22(ji,jj,1,1) - alambd(ji,jj,2,1,2,1) * zs22(ji,jj,2,1)   &
-                    - alambd(ji,jj,2,1,1,2) * zs22(ji,jj,1,2) - alambd(ji,jj,2,1,2,2) * zs22(ji,jj,2,2)
-                 zc2v(ji,jj) =   &
-                    + alambd(ji,jj,2,2,2,1) * zs21(ji,jj,2,1) + alambd(ji,jj,2,2,2,2) * zs21(ji,jj,2,2)   &
-                    - alambd(ji,jj,2,2,1,1) * zs21(ji,jj,1,1) - alambd(ji,jj,2,2,1,2) * zs21(ji,jj,1,2)   &
-                    - alambd(ji,jj,1,1,2,1) * zs22(ji,jj,2,1) - alambd(ji,jj,1,1,1,1) * zs22(ji,jj,1,1)   &
-                    + alambd(ji,jj,1,1,2,2) * zs22(ji,jj,2,2) + alambd(ji,jj,1,1,1,2) * zs22(ji,jj,1,2)   &
-                    - alambd(ji,jj,1,2,1,1) * zs11(ji,jj,1,1) - alambd(ji,jj,1,2,2,1) * zs11(ji,jj,2,1)   &
-                    - alambd(ji,jj,1,2,1,2) * zs11(ji,jj,1,2) - alambd(ji,jj,1,2,2,2) * zs11(ji,jj,2,2)   &
-                    + alambd(ji,jj,2,1,1,1) * zs12(ji,jj,1,1) + alambd(ji,jj,2,1,2,1) * zs12(ji,jj,2,1)   &
-                    + alambd(ji,jj,2,1,1,2) * zs12(ji,jj,1,2) + alambd(ji,jj,2,1,2,2) * zs12(ji,jj,2,2)
-              END DO
-           END DO
-
-         ! Relaxation.
-           
-iflag:   DO jter = 1 , nbitdr
-
-            !  Store previous drift field.   
-            DO jj = k_j1, k_jpj-1
-               zu_ice(:,jj) = u_ice(:,jj)
-               zv_ice(:,jj) = v_ice(:,jj)
+               zvis11 = 2.0 * zviseta (ji,jj-1) + dm
+               zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
+               zvis12 =       zviseta (ji,jj-1) + dm
+               zvis21 =       zviseta (ji,jj-1)
+               zdiag = zvis22 * ( akappa(ji,jj-1,1,2) + akappa(ji,jj-1,2,2) )
+               zs11_21 =  zvis11 * akappa(ji,jj-1,1,2) + zdiag
+               zs12_21 = -zvis12 * akappa(ji,jj-1,2,1) - zvis21 * akappa(ji,jj-1,1,1)
+               zs22_21 =  zvis11 * akappa(ji,jj-1,2,2) + zdiag
+               zs21_21 = -zvis12 * akappa(ji,jj-1,1,1) - zvis21 * akappa(ji,jj-1,2,1)
+
+               zvis11 = 2.0 * zviseta (ji-1,jj) + dm
+               zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
+               zvis12 =       zviseta (ji-1,jj) + dm
+               zvis21 =       zviseta (ji-1,jj)
+               zdiag = zvis22 * ( akappa(ji-1,jj,1,2) - akappa(ji-1,jj,2,2) )
+               zs11_12 =  zvis11 * akappa(ji-1,jj,1,2) + zdiag
+               zs12_12 = -zvis12 * akappa(ji-1,jj,2,1) + zvis21 * akappa(ji-1,jj,1,1)
+               zs22_12 = -zvis11 * akappa(ji-1,jj,2,2) + zdiag
+               zs21_12 =  zvis12 * akappa(ji-1,jj,1,1) - zvis21 * akappa(ji-1,jj,2,1)
+
+               zvis11 = 2.0 * zviseta (ji,jj) + dm
+               zvis22 =       zviszeta(ji,jj) - zviseta(ji,jj)
+               zvis12 =       zviseta (ji,jj) + dm
+               zvis21 =       zviseta (ji,jj)
+               zdiag = zvis22 * ( akappa(ji,jj,1,2) - akappa(ji,jj,2,2) )
+               zs11_22 =  zvis11 * akappa(ji,jj,1,2) + zdiag
+               zs12_22 = -zvis12 * akappa(ji,jj,2,1) - zvis21 * akappa(ji,jj,1,1)
+               zs22_22 = -zvis11 * akappa(ji,jj,2,2) + zdiag
+               zs21_22 = -zvis12 * akappa(ji,jj,1,1) - zvis21 * akappa(ji,jj,2,1)
+
+               zc1v(ji,jj) = + alambd(ji,jj,2,2,2,1) * zs11_21 + alambd(ji,jj,2,2,2,2) * zs11_22   &
+                  &          - alambd(ji,jj,2,2,1,1) * zs11_11 - alambd(ji,jj,2,2,1,2) * zs11_12   &
+                  &          - alambd(ji,jj,1,1,2,1) * zs12_21 - alambd(ji,jj,1,1,1,1) * zs12_11   &
+                  &          + alambd(ji,jj,1,1,2,2) * zs12_22 + alambd(ji,jj,1,1,1,2) * zs12_12   &
+                  &          + alambd(ji,jj,1,2,1,1) * zs21_11 + alambd(ji,jj,1,2,2,1) * zs21_21   &
+                  &          + alambd(ji,jj,1,2,1,2) * zs21_12 + alambd(ji,jj,1,2,2,2) * zs21_22   &
+                  &          - alambd(ji,jj,2,1,1,1) * zs22_11 - alambd(ji,jj,2,1,2,1) * zs22_21   &
+                  &          - alambd(ji,jj,2,1,1,2) * zs22_12 - alambd(ji,jj,2,1,2,2) * zs22_22
+
+               zc2v(ji,jj) = + alambd(ji,jj,2,2,2,1) * zs21_21 + alambd(ji,jj,2,2,2,2) * zs21_22   &
+                  &          - alambd(ji,jj,2,2,1,1) * zs21_11 - alambd(ji,jj,2,2,1,2) * zs21_12   &
+                  &          - alambd(ji,jj,1,1,2,1) * zs22_21 - alambd(ji,jj,1,1,1,1) * zs22_11   &
+                  &          + alambd(ji,jj,1,1,2,2) * zs22_22 + alambd(ji,jj,1,1,1,2) * zs22_12   &
+                  &          - alambd(ji,jj,1,2,1,1) * zs11_11 - alambd(ji,jj,1,2,2,1) * zs11_21   &
+                  &          - alambd(ji,jj,1,2,1,2) * zs11_12 - alambd(ji,jj,1,2,2,2) * zs11_22   &
+                  &          + alambd(ji,jj,2,1,1,1) * zs12_11 + alambd(ji,jj,2,1,2,1) * zs12_21   &
+                  &          + alambd(ji,jj,2,1,1,2) * zs12_12 + alambd(ji,jj,2,1,2,2) * zs12_22
             END DO
-
+         END DO
+
+         ! GAUSS-SEIDEL method
+         !                                                      ! ================ !
+iflag:   DO jter = 1 , nbitdr                                   !    Relaxation    !
+            !                                                   ! ================ !
+!CDIR NOVERRCHK
             DO jj = k_j1+1, k_jpj-1
-               zsang  = SIGN( 1.e0, fcor(1,jj) ) * sangvg   ! only the sinus changes its sign with the hemisphere
-               DO ji = 2, jpim1
-                 zur     = u_ice(ji,jj) - u_oce(ji,jj)
-                 zvr     = v_ice(ji,jj) - v_oce(ji,jj)
-                 zmod    = SQRT( zur * zur + zvr * zvr) * ( 1.0 - zfrld(ji,jj) )
-                 za      = rhoco * zmod
-                 zac     = za * cangvg
-                  zmpzas  = alpha * zcorl(ji,jj) + za * zsang
+!CDIR NOVERRCHK
+               DO ji = fs_2, fs_jpim1
+                  !
+                  ze11 =   akappa(ji,jj-1,1,1) * zu_a(ji+1,jj) + akappa(ji,jj-1,1,2) * zv_a(ji+1,jj)
+                  ze12 = + akappa(ji,jj-1,2,2) * zu_a(ji+1,jj) - akappa(ji,jj-1,2,1) * zv_a(ji+1,jj)
+                  ze22 = + akappa(ji,jj-1,2,2) * zv_a(ji+1,jj) + akappa(ji,jj-1,2,1) * zu_a(ji+1,jj)
+                  ze21 =   akappa(ji,jj-1,1,1) * zv_a(ji+1,jj) - akappa(ji,jj-1,1,2) * zu_a(ji+1,jj)
+                  zvis11 = 2.0 * zviseta (ji,jj-1) + dm
+                  zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
+                  zvis12 =       zviseta (ji,jj-1) + dm
+                  zvis21 =       zviseta (ji,jj-1)
+                  zdiag = zvis22 * ( ze11 + ze22 )
+                  zs11_21 =  zvis11 * ze11 + zdiag
+                  zs12_21 =  zvis12 * ze12 + zvis21 * ze21
+                  zs22_21 =  zvis11 * ze22 + zdiag
+                  zs21_21 =  zvis12 * ze21 + zvis21 * ze12
+
+                  ze11 =   akappa(ji-1,jj,1,1) * ( zu_a(ji  ,jj+1) - zu_a(ji-1,jj+1) )   &
+                     &   + akappa(ji-1,jj,1,2) * ( zv_a(ji  ,jj+1) + zv_a(ji-1,jj+1) )
+                  ze12 = + akappa(ji-1,jj,2,2) * ( zu_a(ji-1,jj+1) + zu_a(ji  ,jj+1) )   &
+                     &   - akappa(ji-1,jj,2,1) * ( zv_a(ji-1,jj+1) + zv_a(ji  ,jj+1) )
+                  ze22 = + akappa(ji-1,jj,2,2) * ( zv_a(ji-1,jj+1) + zv_a(ji  ,jj+1) )   &
+                     &   + akappa(ji-1,jj,2,1) * ( zu_a(ji-1,jj+1) + zu_a(ji  ,jj+1) )
+                  ze21 =   akappa(ji-1,jj,1,1) * ( zv_a(ji  ,jj+1) - zv_a(ji-1,jj+1) )   &
+                     &   - akappa(ji-1,jj,1,2) * ( zu_a(ji  ,jj+1) + zu_a(ji-1,jj+1) )
+                  zvis11 = 2.0 * zviseta (ji-1,jj) + dm
+                  zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
+                  zvis12 =       zviseta (ji-1,jj) + dm
+                  zvis21 =       zviseta (ji-1,jj)
+                  zdiag = zvis22 * ( ze11 + ze22 )
+                  zs11_12 =  zvis11 * ze11 + zdiag
+                  zs12_12 =  zvis12 * ze12 + zvis21 * ze21
+                  zs22_12 =  zvis11 * ze22 + zdiag
+                  zs21_12 =  zvis12 * ze21 + zvis21 * ze12
+
+                  ze11 =   akappa(ji,jj,1,1) * ( zu_a(ji+1,jj) + zu_a(ji+1,jj+1) - zu_a(ji  ,jj+1) )   &
+                     &   + akappa(ji,jj,1,2) * ( zv_a(ji+1,jj) + zv_a(ji+1,jj+1) + zv_a(ji  ,jj+1) )
+                  ze12 = - akappa(ji,jj,2,2) * ( zu_a(ji+1,jj) - zu_a(ji  ,jj+1) - zu_a(ji+1,jj+1) )   &
+                     &   - akappa(ji,jj,2,1) * ( zv_a(ji+1,jj) + zv_a(ji  ,jj+1) + zv_a(ji+1,jj+1) )
+                  ze22 = - akappa(ji,jj,2,2) * ( zv_a(ji+1,jj) - zv_a(ji  ,jj+1) - zv_a(ji+1,jj+1) )   &
+                     &   + akappa(ji,jj,2,1) * ( zu_a(ji+1,jj) + zu_a(ji  ,jj+1) + zu_a(ji+1,jj+1) )
+                  ze21 =   akappa(ji,jj,1,1) * ( zv_a(ji+1,jj) + zv_a(ji+1,jj+1) - zv_a(ji  ,jj+1) )   &
+                     &   - akappa(ji,jj,1,2) * ( zu_a(ji+1,jj) + zu_a(ji+1,jj+1) + zu_a(ji  ,jj+1) )
+                  zvis11 = 2.0 * zviseta (ji,jj) + dm
+                  zvis22 =       zviszeta(ji,jj) - zviseta(ji,jj)
+                  zvis12 =       zviseta (ji,jj) + dm
+                  zvis21 =       zviseta (ji,jj)
+                  zdiag = zvis22 * ( ze11 + ze22 )
+                  zs11_22 =  zvis11 * ze11 + zdiag
+                  zs12_22 =  zvis12 * ze12 + zvis21 * ze21
+                  zs22_22 =  zvis11 * ze22 + zdiag
+                  zs21_22 =  zvis12 * ze21 + zvis21 * ze12
+
+            ! 2nd part
+                  ze11 =   akappa(ji-1,jj-1,1,1) * ( zu_a(ji  ,jj-1) - zu_a(ji-1,jj-1) - zu_a(ji-1,jj) )   &
+                     &   + akappa(ji-1,jj-1,1,2) * ( zv_a(ji  ,jj-1) + zv_a(ji-1,jj-1) + zv_a(ji-1,jj) )
+                  ze12 = - akappa(ji-1,jj-1,2,2) * ( zu_a(ji-1,jj-1) + zu_a(ji  ,jj-1) - zu_a(ji-1,jj) )   &
+                     &   - akappa(ji-1,jj-1,2,1) * ( zv_a(ji-1,jj-1) + zv_a(ji  ,jj-1) + zv_a(ji-1,jj) )
+                  ze22 = - akappa(ji-1,jj-1,2,2) * ( zv_a(ji-1,jj-1) + zv_a(ji  ,jj-1) - zv_a(ji-1,jj) )   &
+                     &   + akappa(ji-1,jj-1,2,1) * ( zu_a(ji-1,jj-1) + zu_a(ji  ,jj-1) + zu_a(ji-1,jj) )
+                  ze21 =   akappa(ji-1,jj-1,1,1) * ( zv_a(ji  ,jj-1) - zv_a(ji-1,jj-1) - zv_a(ji-1,jj) )   &
+                     &  -  akappa(ji-1,jj-1,1,2) * ( zu_a(ji  ,jj-1) + zu_a(ji-1,jj-1) + zu_a(ji-1,jj) )
+                  zvis11 = 2.0 * zviseta (ji-1,jj-1) + dm
+                  zvis22 =       zviszeta(ji-1,jj-1) - zviseta(ji-1,jj-1)
+                  zvis12 =       zviseta (ji-1,jj-1) + dm
+                  zvis21 =       zviseta (ji-1,jj-1)
+                  zdiag = zvis22 * ( ze11 + ze22 )
+                  zs11_11 =  zvis11 * ze11 + zdiag
+                  zs12_11 =  zvis12 * ze12 + zvis21 * ze21
+                  zs22_11 =  zvis11 * ze22 + zdiag
+                  zs21_11 =  zvis12 * ze21 + zvis21 * ze12
+
+                  ze11 =   akappa(ji,jj-1,1,1) * ( zu_a(ji+1,jj-1) - zu_a(ji  ,jj-1) )   &
+                     &   + akappa(ji,jj-1,1,2) * ( zv_a(ji+1,jj-1) + zv_a(ji  ,jj-1) )
+                  ze12 = - akappa(ji,jj-1,2,2) * ( zu_a(ji  ,jj-1) + zu_a(ji+1,jj-1) )   &
+                     &   - akappa(ji,jj-1,2,1) * ( zv_a(ji  ,jj-1) + zv_a(ji+1,jj-1) )
+                  ze22 = - akappa(ji,jj-1,2,2) * ( zv_a(ji  ,jj-1) + zv_a(ji+1,jj-1) )   &
+                     &   + akappa(ji,jj-1,2,1) * ( zu_a(ji  ,jj-1) + zu_a(ji+1,jj-1) )
+                  ze21 =   akappa(ji,jj-1,1,1) * ( zv_a(ji+1,jj-1) - zv_a(ji  ,jj-1) )   &
+                     &   - akappa(ji,jj-1,1,2) * ( zu_a(ji+1,jj-1) + zu_a(ji  ,jj-1) )
+                  zvis11 = 2.0 * zviseta (ji,jj-1) + dm
+                  zvis22 =       zviszeta(ji,jj-1) - zviseta(ji,jj-1)
+                  zvis12 =       zviseta (ji,jj-1) + dm
+                  zvis21 =       zviseta (ji,jj-1)
+                  zdiag = zvis22 * ( ze11 + ze22 )
+                  zs11_21 =  zs11_21 + zvis11 * ze11 + zdiag
+                  zs12_21 =  zs12_21 + zvis12 * ze12 + zvis21 * ze21
+                  zs22_21 =  zs22_21 + zvis11 * ze22 + zdiag
+                  zs21_21 =  zs21_21 + zvis12 * ze21 + zvis21 * ze12
+
+                  ze11 = - akappa(ji-1,jj,1,1) * zu_a(ji-1,jj) + akappa(ji-1,jj,1,2) * zv_a(ji-1,jj)
+                  ze12 = - akappa(ji-1,jj,2,2) * zu_a(ji-1,jj) - akappa(ji-1,jj,2,1) * zv_a(ji-1,jj)
+                  ze22 = - akappa(ji-1,jj,2,2) * zv_a(ji-1,jj) + akappa(ji-1,jj,2,1) * zu_a(ji-1,jj)
+                  ze21 = - akappa(ji-1,jj,1,1) * zv_a(ji-1,jj) - akappa(ji-1,jj,1,2) * zu_a(ji-1,jj)
+                  zvis11 = 2.0 * zviseta (ji-1,jj) + dm
+                  zvis22 =       zviszeta(ji-1,jj) - zviseta(ji-1,jj)
+                  zvis12 =       zviseta (ji-1,jj) + dm
+                  zvis21 =       zviseta (ji-1,jj)
+                  zdiag = zvis22 * ( ze11 + ze22 )
+                  zs11_12 =  zs11_12 + zvis11 * ze11 + zdiag
+                  zs12_12 =  zs12_12 + zvis12 * ze12 + zvis21 * ze21
+                  zs22_12 =  zs22_12 + zvis11 * ze22 + zdiag
+                  zs21_12 =  zs21_12 + zvis12 * ze21 + zvis21 * ze12
+
+                  zd1 = + alambd(ji,jj,2,2,2,1) * zs11_21 + alambd(ji,jj,2,2,2,2) * zs11_22  &
+                     &  - alambd(ji,jj,2,2,1,1) * zs11_11 - alambd(ji,jj,2,2,1,2) * zs11_12  &
+                     &  - alambd(ji,jj,1,1,2,1) * zs12_21 - alambd(ji,jj,1,1,1,1) * zs12_11  &
+                     &  + alambd(ji,jj,1,1,2,2) * zs12_22 + alambd(ji,jj,1,1,1,2) * zs12_12  &
+                     &  + alambd(ji,jj,1,2,1,1) * zs21_11 + alambd(ji,jj,1,2,2,1) * zs21_21  &
+                     &  + alambd(ji,jj,1,2,1,2) * zs21_12 + alambd(ji,jj,1,2,2,2) * zs21_22  &
+                     &  - alambd(ji,jj,2,1,1,1) * zs22_11 - alambd(ji,jj,2,1,2,1) * zs22_21  &
+                     &  - alambd(ji,jj,2,1,1,2) * zs22_12 - alambd(ji,jj,2,1,2,2) * zs22_22
+
+                  zd2 = + alambd(ji,jj,2,2,2,1) * zs21_21 + alambd(ji,jj,2,2,2,2) * zs21_22  &
+                     &  - alambd(ji,jj,2,2,1,1) * zs21_11 - alambd(ji,jj,2,2,1,2) * zs21_12  &
+                     &  - alambd(ji,jj,1,1,2,1) * zs22_21 - alambd(ji,jj,1,1,1,1) * zs22_11  &
+                     &  + alambd(ji,jj,1,1,2,2) * zs22_22 + alambd(ji,jj,1,1,1,2) * zs22_12  &
+                     &  - alambd(ji,jj,1,2,1,1) * zs11_11 - alambd(ji,jj,1,2,2,1) * zs11_21  &
+                     &  - alambd(ji,jj,1,2,1,2) * zs11_12 - alambd(ji,jj,1,2,2,2) * zs11_22  &
+                     &  + alambd(ji,jj,2,1,1,1) * zs12_11 + alambd(ji,jj,2,1,2,1) * zs12_21  &
+                     &  + alambd(ji,jj,2,1,1,2) * zs12_12 + alambd(ji,jj,2,1,2,2) * zs12_22
+
+                  zur     = zu_a(ji,jj) - ui_oce(ji,jj)
+                  zvr     = zv_a(ji,jj) - vi_oce(ji,jj)
+!!!!
+                  zmod    = SQRT( zur*zur + zvr*zvr ) * ( 1.0 - zfrld(ji,jj) )
+                  za      = rhoco * zmod
+!!!!
+!!gm chg resul    za      = rhoco * SQRT( zur*zur + zvr*zvr ) * ( 1.0 - zfrld(ji,jj) )
+                  zac     = za * cangvg
+                  zmpzas  = alpha * zcorl(ji,jj) + za * zsang(ji,jj)
                   zmassdt = zusdtp * zmass(ji,jj)
                   zcorlal = ( 1.0 - alpha ) * zcorl(ji,jj)
 
-                  za1(ji,jj) =  zmassdt * zu0(ji,jj) + zcorlal * zv0(ji,jj) + za1ct(ji,jj)   &
-                     &        + za * ( cangvg * u_oce(ji,jj) - zsang * v_oce(ji,jj) )
-
-                  za2(ji,jj) =  zmassdt * zv0(ji,jj) - zcorlal * zu0(ji,jj) + za2ct(ji,jj)   &
-                     &        + za * ( cangvg * v_oce(ji,jj) + zsang * u_oce(ji,jj) )
-
-                  zb1(ji,jj)  = zmassdt + zac - zc1u(ji,jj)
-                  zb2(ji,jj)  = zmpzas  - zc2u(ji,jj)
-                  zc1(ji,jj)  = zmpzas  + zc1v(ji,jj)
-                  zc2(ji,jj)  = zmassdt + zac  - zc2v(ji,jj) 
-                  zdeter      = zc1(ji,jj) * zb2(ji,jj) + zc2(ji,jj) * zb1(ji,jj)
-                  zden(ji,jj) = SIGN( rone, zdeter) / MAX( epsd , ABS( zdeter ) )
+                  za1 =  zmassdt * zu0(ji,jj) + zcorlal * zv0(ji,jj) + za1ct(ji,jj)   &
+                     &        + za * ( cangvg * ui_oce(ji,jj) - zsang(ji,jj) * vi_oce(ji,jj) )
+                  za2 =  zmassdt * zv0(ji,jj) - zcorlal * zu0(ji,jj) + za2ct(ji,jj)   &
+                     &        + za * ( cangvg * vi_oce(ji,jj) + zsang(ji,jj) * ui_oce(ji,jj) )
+                  zb1    = zmassdt + zac - zc1u(ji,jj)
+                  zb2    = zmpzas        - zc2u(ji,jj)
+                  zc1    = zmpzas        + zc1v(ji,jj)
+                  zc2    = zmassdt + zac - zc2v(ji,jj)
+                  zdeter = zc1 * zb2 + zc2 * zb1
+                  zden   = SIGN( rone, zdeter) / MAX( epsd , ABS( zdeter ) )
+                  zunw   = (  ( za1 + zd1 ) * zc2 + ( za2 + zd2 ) * zc1 ) * zden
+                  zvnw   = (  ( za2 + zd2 ) * zb1 - ( za1 + zd1 ) * zb2 ) * zden
+                  zmask  = ( 1.0 - MAX( rzero, SIGN( rone , 1.0 - zmass(ji,jj) ) ) ) * tmu(ji,jj)
+
+                  zu_n(ji,jj) = ( zu_a(ji,jj) + om * ( zunw - zu_a(ji,jj) ) * tmu(ji,jj) ) * zmask
+                  zv_n(ji,jj) = ( zv_a(ji,jj) + om * ( zvnw - zv_a(ji,jj) ) * tmu(ji,jj) ) * zmask
                END DO
             END DO
 
-            ! The computation of ice interaction term is splitted into two parts
-            !-------------------------------------------------------------------------
-
-            ! Terms that do not involve already up-dated velocities.
-         
-            DO jj = k_j1+1, k_jpj-1
-               DO ji = 2, jpim1
-                  iim1 = ji
-                  ijm1 = jj - 1
-                  iip1 = ji + 1
-                  ijp1 = jj
-                  ze11 =   akappa(iim1,ijm1,1,1) * u_ice(iip1,ijp1) + akappa(iim1,ijm1,1,2) * v_ice(iip1,ijp1)
-                  ze12 = + akappa(iim1,ijm1,2,2) * u_ice(iip1,ijp1) - akappa(iim1,ijm1,2,1) * v_ice(iip1,ijp1)
-                  ze22 = + akappa(iim1,ijm1,2,2) * v_ice(iip1,ijp1) + akappa(iim1,ijm1,2,1) * u_ice(iip1,ijp1)
-                  ze21 =   akappa(iim1,ijm1,1,1) * v_ice(iip1,ijp1) - akappa(iim1,ijm1,1,2) * u_ice(iip1,ijp1)
-                  zvis11 = 2.0 * zviseta (iim1,ijm1) + dm
-                  zvis22 =       zviszeta(iim1,ijm1) - zviseta(iim1,ijm1)
-                  zvis12 =       zviseta (iim1,ijm1) + dm
-                  zvis21 =       zviseta (iim1,ijm1)
-                  zdiag = zvis22 * ( ze11 + ze22 )
-                  zs11(ji,jj,2,1) =  zvis11 * ze11 + zdiag
-                  zs12(ji,jj,2,1) =  zvis12 * ze12 + zvis21 * ze21
-                  zs22(ji,jj,2,1) =  zvis11 * ze22 + zdiag
-                  zs21(ji,jj,2,1) =  zvis12 * ze21 + zvis21 * ze12
-
-
-                  iim1 = ji - 1
-                  ijm1 = jj
-                  iip1 = ji
-                  ijp1 = jj + 1                   
-                  ze11 =   akappa(iim1,ijm1,1,1) * ( u_ice(iip1,ijp1) - u_ice(iim1,ijp1) )   &
-                     &   + akappa(iim1,ijm1,1,2) * ( v_ice(iip1,ijp1) + v_ice(iim1,ijp1) )
-                  ze12 = + akappa(iim1,ijm1,2,2) * ( u_ice(iim1,ijp1) + u_ice(iip1,ijp1) )   &
-                     &   - akappa(iim1,ijm1,2,1) * ( v_ice(iim1,ijp1) + v_ice(iip1,ijp1) )
-                  ze22 = + akappa(iim1,ijm1,2,2) * ( v_ice(iim1,ijp1) + v_ice(iip1,ijp1) )   &
-                     &   + akappa(iim1,ijm1,2,1) * ( u_ice(iim1,ijp1) + u_ice(iip1,ijp1) )
-                  ze21 =   akappa(iim1,ijm1,1,1) * ( v_ice(iip1,ijp1) - v_ice(iim1,ijp1) )   &
-                     &   - akappa(iim1,ijm1,1,2) * ( u_ice(iip1,ijp1) + u_ice(iim1,ijp1) )
-                  zvis11 = 2.0 * zviseta (iim1,ijm1) + dm
-                  zvis22 =       zviszeta(iim1,ijm1) - zviseta(iim1,ijm1)
-                  zvis12 =       zviseta (iim1,ijm1) + dm
-                  zvis21 =       zviseta (iim1,ijm1)
-                  zdiag = zvis22 * ( ze11 + ze22 )
-                  zs11(ji,jj,1,2) =  zvis11 * ze11 + zdiag
-                  zs12(ji,jj,1,2) =  zvis12 * ze12 + zvis21 * ze21
-                  zs22(ji,jj,1,2) =  zvis11 * ze22 + zdiag
-                  zs21(ji,jj,1,2) =  zvis12 * ze21 + zvis21 * ze12
-
-                  iim1 = ji
-                  ijm1 = jj
-                  iip1 = ji + 1
-                  ijp1 = jj + 1
-                  ze11 =   akappa(iim1,ijm1,1,1) * ( u_ice(iip1,ijm1) + u_ice(iip1,ijp1) - u_ice(iim1,ijp1) )   &
-                     &   + akappa(iim1,ijm1,1,2) * ( v_ice(iip1,ijm1) + v_ice(iip1,ijp1) + v_ice(iim1,ijp1) )
-                  ze12 = - akappa(iim1,ijm1,2,2) * ( u_ice(iip1,ijm1) - u_ice(iim1,ijp1) - u_ice(iip1,ijp1) )   &
-                     &   - akappa(iim1,ijm1,2,1) * ( v_ice(iip1,ijm1) + v_ice(iim1,ijp1) + v_ice(iip1,ijp1) )
-                  ze22 = - akappa(iim1,ijm1,2,2) * ( v_ice(iip1,ijm1) - v_ice(iim1,ijp1) - v_ice(iip1,ijp1) )   &
-                     &   + akappa(iim1,ijm1,2,1) * ( u_ice(iip1,ijm1) + u_ice(iim1,ijp1) + u_ice(iip1,ijp1) )
-                  ze21 =   akappa(iim1,ijm1,1,1) * ( v_ice(iip1,ijm1) + v_ice(iip1,ijp1) - v_ice(iim1,ijp1) )   &
-                     &   - akappa(iim1,ijm1,1,2) * ( u_ice(iip1,ijm1) + u_ice(iip1,ijp1) + u_ice(iim1,ijp1) ) 
-                  zvis11 = 2.0 * zviseta (iim1,ijm1) + dm
-                  zvis22 =       zviszeta(iim1,ijm1) - zviseta(iim1,ijm1)
-                  zvis12 =       zviseta (iim1,ijm1) + dm
-                  zvis21 =       zviseta (iim1,ijm1)
-
-                  zdiag = zvis22 * ( ze11 + ze22 )
-                  zs11(ji,jj,2,2) =  zvis11 * ze11 + zdiag
-                  zs12(ji,jj,2,2) =  zvis12 * ze12 + zvis21 * ze21
-                  zs22(ji,jj,2,2) =  zvis11 * ze22 + zdiag
-                  zs21(ji,jj,2,2) =  zvis12 * ze21 + zvis21 * ze12
-
-               END DO
+            CALL lbc_lnk( zu_n(:,1:jpj), 'I', -1. )
+            CALL lbc_lnk( zv_n(:,1:jpj), 'I', -1. )
+
+            ! Test of Convergence
+            DO jj = k_j1+1 , k_jpj-1
+               zresr(:,jj) = MAX( ABS( zu_a(:,jj) - zu_n(:,jj) ) , ABS( zv_a(:,jj) - zv_n(:,jj) ) )
             END DO
-
-            ! Terms involving already up-dated velocities.
-            !-Using the arrays zu_ice and zv_ice in the computation of the terms ze leads to JACOBI's method; 
-            ! Using arrays u and v in the computation of the terms ze leads to GAUSS-SEIDEL method.
-             
-            DO jj = k_j1+1, k_jpj-1
-               DO ji = 2, jpim1
-                  iim1 = ji - 1
-                  ijm1 = jj - 1
-                  iip1 = ji
-                  ijp1 = jj
-                  ze11 =   akappa(iim1,ijm1,1,1) * ( zu_ice(iip1,ijm1) - zu_ice(iim1,ijm1) - zu_ice(iim1,ijp1) )   &
-                     &   + akappa(iim1,ijm1,1,2) * ( zv_ice(iip1,ijm1) + zv_ice(iim1,ijm1) + zv_ice(iim1,ijp1) )
-                  ze12 = - akappa(iim1,ijm1,2,2) * ( zu_ice(iim1,ijm1) + zu_ice(iip1,ijm1) - zu_ice(iim1,ijp1) )   &
-                     &   - akappa(iim1,ijm1,2,1) * ( zv_ice(iim1,ijm1) + zv_ice(iip1,ijm1) + zv_ice(iim1,ijp1) )
-                  ze22 = - akappa(iim1,ijm1,2,2) * ( zv_ice(iim1,ijm1) + zv_ice(iip1,ijm1) - zv_ice(iim1,ijp1) )   &
-                     &   + akappa(iim1,ijm1,2,1) * ( zu_ice(iim1,ijm1) + zu_ice(iip1,ijm1) + zu_ice(iim1,ijp1) )
-                  ze21 =   akappa(iim1,ijm1,1,1) * ( zv_ice(iip1,ijm1) - zv_ice(iim1,ijm1) - zv_ice(iim1,ijp1) )   &
-                     &  -  akappa(iim1,ijm1,1,2) * ( zu_ice(iip1,ijm1) + zu_ice(iim1,ijm1) + zu_ice(iim1,ijp1) )
-                  zvis11 = 2.0 * zviseta (iim1,ijm1) + dm
-                  zvis22 =       zviszeta(iim1,ijm1) - zviseta(iim1,ijm1)
-                  zvis12 =       zviseta (iim1,ijm1) + dm
-                  zvis21 =       zviseta (iim1,ijm1)
-
-                  zdiag = zvis22 * ( ze11 + ze22 )
-                  zs11(ji,jj,1,1) =  zvis11 * ze11 + zdiag
-                  zs12(ji,jj,1,1) =  zvis12 * ze12 + zvis21 * ze21
-                  zs22(ji,jj,1,1) =  zvis11 * ze22 + zdiag
-                  zs21(ji,jj,1,1) =  zvis12 * ze21 + zvis21 * ze12
-
-#if defined key_agrif
-             END DO
-          END DO
-
-          DO jj = k_j1+1, k_jpj-1
-             DO ji = 2, jpim1
-#endif
-
-                  iim1 = ji
-                  ijm1 = jj - 1
-                  iip1 = ji + 1
-                  ze11 =   akappa(iim1,ijm1,1,1) * ( zu_ice(iip1,ijm1) - zu_ice(iim1,ijm1) )   &
-                     &   + akappa(iim1,ijm1,1,2) * ( zv_ice(iip1,ijm1) + zv_ice(iim1,ijm1) )
-                  ze12 = - akappa(iim1,ijm1,2,2) * ( zu_ice(iim1,ijm1) + zu_ice(iip1,ijm1) )   &
-                     &   - akappa(iim1,ijm1,2,1) * ( zv_ice(iim1,ijm1) + zv_ice(iip1,ijm1) )
-                  ze22 = - akappa(iim1,ijm1,2,2) * ( zv_ice(iim1,ijm1) + zv_ice(iip1,ijm1) )   &
-                     &   + akappa(iim1,ijm1,2,1) * ( zu_ice(iim1,ijm1) + zu_ice(iip1,ijm1) )
-                  ze21 =   akappa(iim1,ijm1,1,1) * ( zv_ice(iip1,ijm1) - zv_ice(iim1,ijm1) )   &
-                     &   - akappa(iim1,ijm1,1,2) * ( zu_ice(iip1,ijm1) + zu_ice(iim1,ijm1) )
-                  zvis11 = 2.0 * zviseta (iim1,ijm1) + dm
-                  zvis22 =       zviszeta(iim1,ijm1) - zviseta(iim1,ijm1)
-                  zvis12 =       zviseta (iim1,ijm1) + dm
-                  zvis21 =       zviseta (iim1,ijm1)
-
-                  zdiag = zvis22 * ( ze11 + ze22 )
-                  zs11(ji,jj,2,1) =  zs11(ji,jj,2,1) + zvis11 * ze11 + zdiag
-                  zs12(ji,jj,2,1) =  zs12(ji,jj,2,1) + zvis12 * ze12 + zvis21 * ze21
-                  zs22(ji,jj,2,1) =  zs22(ji,jj,2,1) + zvis11 * ze22 + zdiag
-                  zs21(ji,jj,2,1) =  zs21(ji,jj,2,1) + zvis12 * ze21 + zvis21 * ze12
-
-
-                  iim1 = ji - 1
-                  ijm1 = jj 
-                  ze11 = - akappa(iim1,ijm1,1,1) * zu_ice(iim1,ijm1) + akappa(iim1,ijm1,1,2) * zv_ice(iim1,ijm1)
-                  ze12 = - akappa(iim1,ijm1,2,2) * zu_ice(iim1,ijm1) - akappa(iim1,ijm1,2,1) * zv_ice(iim1,ijm1)
-                  ze22 = - akappa(iim1,ijm1,2,2) * zv_ice(iim1,ijm1) + akappa(iim1,ijm1,2,1) * zu_ice(iim1,ijm1)
-                  ze21 = - akappa(iim1,ijm1,1,1) * zv_ice(iim1,ijm1) - akappa(iim1,ijm1,1,2) * zu_ice(iim1,ijm1)
-                  zvis11 = 2.0 * zviseta (iim1,ijm1) + dm
-                  zvis22 =       zviszeta(iim1,ijm1) - zviseta(iim1,ijm1)
-                  zvis12 =       zviseta (iim1,ijm1) + dm
-                  zvis21 =       zviseta (iim1,ijm1)
-
-                  zdiag = zvis22 * ( ze11 + ze22 )
-                  zs11(ji,jj,1,2) =  zs11(ji,jj,1,2) + zvis11 * ze11 + zdiag 
-                  zs12(ji,jj,1,2) =  zs12(ji,jj,1,2) + zvis12 * ze12 + zvis21 * ze21
-                  zs22(ji,jj,1,2) =  zs22(ji,jj,1,2) + zvis11 * ze22 + zdiag
-                  zs21(ji,jj,1,2) =  zs21(ji,jj,1,2) + zvis12 * ze21 + zvis21 * ze12
-
-#if defined key_agrif
-             END DO
-          END DO
-
-          DO jj = k_j1+1, k_jpj-1
-             DO ji = 2, jpim1
-#endif
-                  zd1(ji,jj) =   &
-                     + alambd(ji,jj,2,2,2,1) * zs11(ji,jj,2,1) + alambd(ji,jj,2,2,2,2) * zs11(ji,jj,2,2)  &
-                     - alambd(ji,jj,2,2,1,1) * zs11(ji,jj,1,1) - alambd(ji,jj,2,2,1,2) * zs11(ji,jj,1,2)  &
-                     - alambd(ji,jj,1,1,2,1) * zs12(ji,jj,2,1) - alambd(ji,jj,1,1,1,1) * zs12(ji,jj,1,1)  &
-                     + alambd(ji,jj,1,1,2,2) * zs12(ji,jj,2,2) + alambd(ji,jj,1,1,1,2) * zs12(ji,jj,1,2)  &
-                     + alambd(ji,jj,1,2,1,1) * zs21(ji,jj,1,1) + alambd(ji,jj,1,2,2,1) * zs21(ji,jj,2,1)  &
-                     + alambd(ji,jj,1,2,1,2) * zs21(ji,jj,1,2) + alambd(ji,jj,1,2,2,2) * zs21(ji,jj,2,2)  &
-                     - alambd(ji,jj,2,1,1,1) * zs22(ji,jj,1,1) - alambd(ji,jj,2,1,2,1) * zs22(ji,jj,2,1)  &
-                     - alambd(ji,jj,2,1,1,2) * zs22(ji,jj,1,2) - alambd(ji,jj,2,1,2,2) * zs22(ji,jj,2,2)
-                  zd2(ji,jj) =   &
-                     + alambd(ji,jj,2,2,2,1) * zs21(ji,jj,2,1) + alambd(ji,jj,2,2,2,2) * zs21(ji,jj,2,2)  &
-                     - alambd(ji,jj,2,2,1,1) * zs21(ji,jj,1,1) - alambd(ji,jj,2,2,1,2) * zs21(ji,jj,1,2)  &
-                     - alambd(ji,jj,1,1,2,1) * zs22(ji,jj,2,1) - alambd(ji,jj,1,1,1,1) * zs22(ji,jj,1,1)  &
-                     + alambd(ji,jj,1,1,2,2) * zs22(ji,jj,2,2) + alambd(ji,jj,1,1,1,2) * zs22(ji,jj,1,2)  &
-                     - alambd(ji,jj,1,2,1,1) * zs11(ji,jj,1,1) - alambd(ji,jj,1,2,2,1) * zs11(ji,jj,2,1)  &
-                     - alambd(ji,jj,1,2,1,2) * zs11(ji,jj,1,2) - alambd(ji,jj,1,2,2,2) * zs11(ji,jj,2,2)  &
-                     + alambd(ji,jj,2,1,1,1) * zs12(ji,jj,1,1) + alambd(ji,jj,2,1,2,1) * zs12(ji,jj,2,1)  &
-                     + alambd(ji,jj,2,1,1,2) * zs12(ji,jj,1,2) + alambd(ji,jj,2,1,2,2) * zs12(ji,jj,2,2)
-               END DO
+            zresm = MAXVAL( zresr(1:jpi,k_j1+1:k_jpj-1) )
+!!!! this should be faster on scalar processor
+!           zresm = MAXVAL(  MAX( ABS( zu_a(1:jpi,k_j1+1:k_jpj-1) - zu_n(1:jpi,k_j1+1:k_jpj-1) ),   &
+!              &                  ABS( zv_a(1:jpi,k_j1+1:k_jpj-1) - zv_n(1:jpi,k_j1+1:k_jpj-1) ) )  )
+!!!!
+            IF( lk_mpp )   CALL mpp_max( zresm )   ! max over the global domain
+
+            DO jj = k_j1, k_jpj
+               zu_a(:,jj) = zu_n(:,jj)
+               zv_a(:,jj) = zv_n(:,jj)
             END DO
 
-            DO jj = k_j1+1, k_jpj-1
-               DO ji = 2, jpim1
-                  zunw = (  ( za1(ji,jj) + zd1(ji,jj) ) * zc2(ji,jj)        &
-                     &    + ( za2(ji,jj) + zd2(ji,jj) ) * zc1(ji,jj) ) * zden(ji,jj)
-
-                  zvnw = (  ( za2(ji,jj) + zd2(ji,jj) ) * zb1(ji,jj)        &
-                     &    - ( za1(ji,jj) + zd1(ji,jj) ) * zb2(ji,jj) ) * zden(ji,jj)
-
-                  zmask = ( 1.0 - MAX( rzero, SIGN( rone , 1.0 - zmass(ji,jj) ) ) ) * tmu(ji,jj)
-
-                  u_ice(ji,jj) = ( u_ice(ji,jj) + om * ( zunw - u_ice(ji,jj) ) * tmu(ji,jj) ) * zmask
-                  v_ice(ji,jj) = ( v_ice(ji,jj) + om * ( zvnw - v_ice(ji,jj) ) * tmu(ji,jj) ) * zmask
-               END DO
+            IF( zresm <= resl )   EXIT   iflag
+
+            !                                                   ! ================ !
+         END DO    iflag                                        !  end Relaxation  !
+         !                                                      ! ================ !
+
+         IF( zindu == 0 ) THEN      ! even iteration
+            DO jj = k_j1 , k_jpj-1
+               zu0(:,jj) = zu_a(:,jj)
+               zv0(:,jj) = zv_a(:,jj)
             END DO
-
-            CALL lbc_lnk( u_ice, 'I', -1. )
-            CALL lbc_lnk( v_ice, 'I', -1. )
-
-            !---  5.2.5.4. Convergence test.
-            DO jj = k_j1+1 , k_jpj-1
-               zresr(:,jj) = MAX( ABS( u_ice(:,jj) - zu_ice(:,jj) ) , ABS( v_ice(:,jj) - zv_ice(:,jj) ) )
-            END DO
-            zresm = MAXVAL( zresr( 1:jpi , k_j1+1:k_jpj-1 ) )
-            IF( lk_mpp )   CALL mpp_max( zresm )   ! max over the global domain
-
-            IF ( zresm <= resl) EXIT iflag
-
-         END DO iflag
-
-         zindu1 = 1.0 - zindu
-         DO jj = k_j1 , k_jpj-1
-            zu0(:,jj) = zindu * zu0(:,jj) + zindu1 * u_ice(:,jj)
-            zv0(:,jj) = zindu * zv0(:,jj) + zindu1 * v_ice(:,jj)
-         END DO
-      !                                                   ! ==================== !
+         ENDIF
+         !                                                ! ==================== !
       END DO                                              !  end loop over iter  !
       !                                                   ! ==================== !
+
+      ui_ice(:,:) = zu_a(:,1:jpj)
+      vi_ice(:,:) = zv_a(:,1:jpj)
 
       IF(ln_ctl) THEN
          WRITE(charout,FMT="('lim_rhg  : res =',D23.16, ' iter =',I4)") zresm, jter
          CALL prt_ctl_info(charout)
-         CALL prt_ctl(tab2d_1=u_ice, clinfo1=' lim_rhg  : u_ice :', tab2d_2=v_ice, clinfo2=' v_ice :')
+         CALL prt_ctl(tab2d_1=ui_ice, clinfo1=' lim_rhg  : ui_ice :', tab2d_2=vi_ice, clinfo2=' vi_ice :')
       ENDIF
 
